/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#include <nostalgia/core/gfx.hpp>

#include "sceneeditorview.hpp"

namespace nostalgia::scene {

SceneEditorView::SceneEditorView(turbine::Context &tctx, SceneStatic const&sceneStatic):
	m_sceneStatic(sceneStatic),
	m_scene(m_sceneStatic) {
	oxThrowError(core::init(tctx, {.glInstallDrawer = false}).moveTo(&m_cctx));
}

ox::Error SceneEditorView::setupScene() noexcept {
	return m_scene.setupDisplay(*m_cctx);
}

void SceneEditorView::draw(int width, int height) noexcept {
	if (width != m_frameBuffer.width || height != m_frameBuffer.height) {
		glutils::resizeInitFrameBuffer(m_frameBuffer, width, height);
	}
	glutils::FrameBufferBind const frameBufferBind(m_frameBuffer);
	core::gl::draw(*m_cctx, {width, height});
}

glutils::FrameBuffer const&SceneEditorView::framebuffer() const noexcept {
	return m_frameBuffer;
}

}
